Index: main/pbx.c
===================================================================
--- main/pbx.c	(revision 92526)
+++ main/pbx.c	(working copy)
@@ -7400,34 +7400,44 @@
 			return -1;
 		}
 	}
+
+	if (chan->_state != AST_STATE_UP)
+		ast_answer(chan);
+
 	return ast_say_number(chan, atoi(tmp), "", chan->language, options);
 }
 
 static int pbx_builtin_saydigits(struct ast_channel *chan, void *data)
 {
-	int res = 0;
+	if (!data)
+		return 0;
 
-	if (data)
-		res = ast_say_digit_str(chan, data, "", chan->language);
-	return res;
+	if (chan->_state != AST_STATE_UP)
+		ast_answer(chan);
+
+	return ast_say_digit_str(chan, data, "", chan->language);
 }
 
 static int pbx_builtin_saycharacters(struct ast_channel *chan, void *data)
 {
-	int res = 0;
+	if (!data)
+		return 0;
 
-	if (data)
-		res = ast_say_character_str(chan, data, "", chan->language);
-	return res;
+	if (chan->_state != AST_STATE_UP)
+		ast_answer(chan);
+
+	return ast_say_character_str(chan, data, "", chan->language);
 }
 
 static int pbx_builtin_sayphonetic(struct ast_channel *chan, void *data)
 {
-	int res = 0;
+	if (!data)
+		return 0;
 
-	if (data)
-		res = ast_say_phonetic_str(chan, data, "", chan->language);
-	return res;
+	if (chan->_state != AST_STATE_UP)
+		ast_answer(chan);
+
+	return ast_say_phonetic_str(chan, data, "", chan->language);
 }
 
 static void device_state_cb(const struct ast_event *event, void *unused)
